// SPDX-License-Identifier: Unlicense OR BSD-3-Clause

package unicodedata

import "unicode"

// Code generated by typesettings-utils/generators/unicodedata/cmd/main.go DO NOT EDIT.

// LargeEastAsian matches runes with East_Asian_Width property of
// F, W or H, and is used for UAX14, rule LB30.
var LargeEastAsian = &unicode.RangeTable{
	R16: []unicode.Range16{
		{Lo: 0x1100, Hi: 0x115f, Stride: 1},
		{Lo: 0x20a9, Hi: 0x231a, Stride: 625},
		{Lo: 0x231b, Hi: 0x2329, Stride: 14},
		{Lo: 0x232a, Hi: 0x23e9, Stride: 191},
		{Lo: 0x23ea, Hi: 0x23ec, Stride: 1},
		{Lo: 0x23f0, Hi: 0x23f3, Stride: 3},
		{Lo: 0x25fd, Hi: 0x25fe, Stride: 1},
		{Lo: 0x2614, Hi: 0x2615, Stride: 1},
		{Lo: 0x2648, Hi: 0x2653, Stride: 1},
		{Lo: 0x267f, Hi: 0x2693, Stride: 20},
		{Lo: 0x26a1, Hi: 0x26aa, Stride: 9},
		{Lo: 0x26ab, Hi: 0x26bd, Stride: 18},
		{Lo: 0x26be, Hi: 0x26c4, Stride: 6},
		{Lo: 0x26c5, Hi: 0x26ce, Stride: 9},
		{Lo: 0x26d4, Hi: 0x26ea, Stride: 22},
		{Lo: 0x26f2, Hi: 0x26f3, Stride: 1},
		{Lo: 0x26f5, Hi: 0x26fa, Stride: 5},
		{Lo: 0x26fd, Hi: 0x2705, Stride: 8},
		{Lo: 0x270a, Hi: 0x270b, Stride: 1},
		{Lo: 0x2728, Hi: 0x274c, Stride: 36},
		{Lo: 0x274e, Hi: 0x2753, Stride: 5},
		{Lo: 0x2754, Hi: 0x2755, Stride: 1},
		{Lo: 0x2757, Hi: 0x2795, Stride: 62},
		{Lo: 0x2796, Hi: 0x2797, Stride: 1},
		{Lo: 0x27b0, Hi: 0x27bf, Stride: 15},
		{Lo: 0x2b1b, Hi: 0x2b1c, Stride: 1},
		{Lo: 0x2b50, Hi: 0x2b55, Stride: 5},
		{Lo: 0x2e80, Hi: 0x2e99, Stride: 1},
		{Lo: 0x2e9b, Hi: 0x2ef3, Stride: 1},
		{Lo: 0x2f00, Hi: 0x2fd5, Stride: 1},
		{Lo: 0x2ff0, Hi: 0x2ffb, Stride: 1},
		{Lo: 0x3000, Hi: 0x303e, Stride: 1},
		{Lo: 0x3041, Hi: 0x3096, Stride: 1},
		{Lo: 0x3099, Hi: 0x30ff, Stride: 1},
		{Lo: 0x3105, Hi: 0x312f, Stride: 1},
		{Lo: 0x3131, Hi: 0x318e, Stride: 1},
		{Lo: 0x3190, Hi: 0x31e3, Stride: 1},
		{Lo: 0x31f0, Hi: 0x321e, Stride: 1},
		{Lo: 0x3220, Hi: 0x3247, Stride: 1},
		{Lo: 0x3250, Hi: 0x4dbf, Stride: 1},
		{Lo: 0x4e00, Hi: 0xa48c, Stride: 1},
		{Lo: 0xa490, Hi: 0xa4c6, Stride: 1},
		{Lo: 0xa960, Hi: 0xa97c, Stride: 1},
		{Lo: 0xac00, Hi: 0xd7a3, Stride: 1},
		{Lo: 0xf900, Hi: 0xfaff, Stride: 1},
		{Lo: 0xfe10, Hi: 0xfe19, Stride: 1},
		{Lo: 0xfe30, Hi: 0xfe52, Stride: 1},
		{Lo: 0xfe54, Hi: 0xfe66, Stride: 1},
		{Lo: 0xfe68, Hi: 0xfe6b, Stride: 1},
		{Lo: 0xff01, Hi: 0xffbe, Stride: 1},
		{Lo: 0xffc2, Hi: 0xffc7, Stride: 1},
		{Lo: 0xffca, Hi: 0xffcf, Stride: 1},
		{Lo: 0xffd2, Hi: 0xffd7, Stride: 1},
		{Lo: 0xffda, Hi: 0xffdc, Stride: 1},
		{Lo: 0xffe0, Hi: 0xffe6, Stride: 1},
		{Lo: 0xffe8, Hi: 0xffee, Stride: 1},
	},
	R32: []unicode.Range32{
		{Lo: 0x16fe0, Hi: 0x16fe4, Stride: 1},
		{Lo: 0x16ff0, Hi: 0x16ff1, Stride: 1},
		{Lo: 0x17000, Hi: 0x187f7, Stride: 1},
		{Lo: 0x18800, Hi: 0x18cd5, Stride: 1},
		{Lo: 0x18d00, Hi: 0x18d08, Stride: 1},
		{Lo: 0x1b000, Hi: 0x1b11e, Stride: 1},
		{Lo: 0x1b150, Hi: 0x1b152, Stride: 1},
		{Lo: 0x1b164, Hi: 0x1b167, Stride: 1},
		{Lo: 0x1b170, Hi: 0x1b2fb, Stride: 1},
		{Lo: 0x1f004, Hi: 0x1f0cf, Stride: 203},
		{Lo: 0x1f18e, Hi: 0x1f191, Stride: 3},
		{Lo: 0x1f192, Hi: 0x1f19a, Stride: 1},
		{Lo: 0x1f200, Hi: 0x1f202, Stride: 1},
		{Lo: 0x1f210, Hi: 0x1f23b, Stride: 1},
		{Lo: 0x1f240, Hi: 0x1f248, Stride: 1},
		{Lo: 0x1f250, Hi: 0x1f251, Stride: 1},
		{Lo: 0x1f260, Hi: 0x1f265, Stride: 1},
		{Lo: 0x1f300, Hi: 0x1f320, Stride: 1},
		{Lo: 0x1f32d, Hi: 0x1f335, Stride: 1},
		{Lo: 0x1f337, Hi: 0x1f37c, Stride: 1},
		{Lo: 0x1f37e, Hi: 0x1f393, Stride: 1},
		{Lo: 0x1f3a0, Hi: 0x1f3ca, Stride: 1},
		{Lo: 0x1f3cf, Hi: 0x1f3d3, Stride: 1},
		{Lo: 0x1f3e0, Hi: 0x1f3f0, Stride: 1},
		{Lo: 0x1f3f4, Hi: 0x1f3f8, Stride: 4},
		{Lo: 0x1f3f9, Hi: 0x1f43e, Stride: 1},
		{Lo: 0x1f440, Hi: 0x1f442, Stride: 2},
		{Lo: 0x1f443, Hi: 0x1f4fc, Stride: 1},
		{Lo: 0x1f4ff, Hi: 0x1f53d, Stride: 1},
		{Lo: 0x1f54b, Hi: 0x1f54e, Stride: 1},
		{Lo: 0x1f550, Hi: 0x1f567, Stride: 1},
		{Lo: 0x1f57a, Hi: 0x1f595, Stride: 27},
		{Lo: 0x1f596, Hi: 0x1f5a4, Stride: 14},
		{Lo: 0x1f5fb, Hi: 0x1f64f, Stride: 1},
		{Lo: 0x1f680, Hi: 0x1f6c5, Stride: 1},
		{Lo: 0x1f6cc, Hi: 0x1f6d0, Stride: 4},
		{Lo: 0x1f6d1, Hi: 0x1f6d2, Stride: 1},
		{Lo: 0x1f6d5, Hi: 0x1f6d7, Stride: 1},
		{Lo: 0x1f6eb, Hi: 0x1f6ec, Stride: 1},
		{Lo: 0x1f6f4, Hi: 0x1f6fc, Stride: 1},
		{Lo: 0x1f7e0, Hi: 0x1f7eb, Stride: 1},
		{Lo: 0x1f90c, Hi: 0x1f93a, Stride: 1},
		{Lo: 0x1f93c, Hi: 0x1f945, Stride: 1},
		{Lo: 0x1f947, Hi: 0x1f978, Stride: 1},
		{Lo: 0x1f97a, Hi: 0x1f9cb, Stride: 1},
		{Lo: 0x1f9cd, Hi: 0x1f9ff, Stride: 1},
		{Lo: 0x1fa70, Hi: 0x1fa74, Stride: 1},
		{Lo: 0x1fa78, Hi: 0x1fa7a, Stride: 1},
		{Lo: 0x1fa80, Hi: 0x1fa86, Stride: 1},
		{Lo: 0x1fa90, Hi: 0x1faa8, Stride: 1},
		{Lo: 0x1fab0, Hi: 0x1fab6, Stride: 1},
		{Lo: 0x1fac0, Hi: 0x1fac2, Stride: 1},
		{Lo: 0x1fad0, Hi: 0x1fad6, Stride: 1},
		{Lo: 0x20000, Hi: 0x2fffd, Stride: 1},
		{Lo: 0x30000, Hi: 0x3fffd, Stride: 1},
	},
}
